<template>
    <div v-if="editMode" class="row">
        <div class="col-12">
            <BudgetAliasAdd
                class="p-1 addCell"
                :codesList="codesList"
                :newAlias="newAlias"
                @aliasAddClicked="addAlias"/>
        </div>
    </div>
    <div class="row mt-3">
        <div class="col-12">
            <Tree :value="aliasesTree"
                :draggable="editMode"
                :droppable="editMode"
                @change="treeChanged"
                v-slot="{node, path, tree}">
                <BudgetAliasTreeNode
                    :node="node"
                    :editMode="editMode"
                    :codesList="codesList"
                    @click="nodeClicked"
                    @change="aliasNodeChanged(node)"
                    @nodeToggleClicked="tree.toggleFold(node, path)"
                    @nodeCopyClicked="copyAliasNode(node, path, tree)"
                    @nodeDeleteClicked="deleteAliasNode(node, path, tree)"/>
            </Tree>
        </div>
    </div>
</template>

<style>
    .addCell {
        border: 1px solid lightgray;
    }
    .zero-height-button {
        line-height: 0!important;
    }
    .button-block {
        min-width: 10em;
        margin-left: .25rem!important;
    }
    .node-warning {
        color: lightcoral;
        font-size: 0.7em;
    }
    .he-tree .node{
        border: 1px solid #ccc;
        margin-bottom: 5px;
        padding: 5px;
    }
    .he-tree .node.is-secondary {
        border-style: dashed;
        background: whitesmoke;
        color: gray;
        font-style: italic;
    }
    .he-tree .tree-placeholder-node{
        background: #ddf2f9;
        border: 1px dashed #00d9ff;
        height: 20px;
    }
    .he-tree .dragging .tree-node-back:hover{
        background-color: inherit;
    }
</style>

<script>
    import BudgetAliasAdd from './BudgetAliasAdd'
    import BudgetAliasTreeNode from './BudgetAliasTreeNode'
    import { BudgetAliasesService } from '../../services/budgetAliasesService'
    import { defaultHandleErrorFunction } from '@/services/http-common'
    import {Tree, Fold, Draggable} from 'he-tree-vue'

    export default {
        name: "BudgetAliasesTree",
        components: {
            Tree: Tree.mixPlugins([Fold, Draggable]),
            BudgetAliasAdd,
            BudgetAliasTreeNode
        },
        props: {
            aliasesList: Array,
            codesList: Array,
            presentationId: Number,
            codeType: String,
            editMode: Boolean
        },
        data() {
            return {
                newAlias: {
                    codeId: null,
                    name: ""
                },
                aliasesTree: [],
                nextNodeId: 0
            }
        },
        methods: {
            updateAliasTree(inputAliasesList) {
                let nodes = [], i, j;
                this.aliasesTree = [];

                for (i = 0; i < inputAliasesList.length; i += 1) {
                    let alias = inputAliasesList[i];
                    nodes[i] = this.createPrimaryNode(alias);
                }

                for (i = 0; i < inputAliasesList.length; i += 1) {
                    let alias = inputAliasesList[i];
                    let node = nodes[i];

                    if (alias.parentsRelations.length == 0)
                        this.aliasesTree.push(node);
                    else {
                        node.hasCopy = alias.parentsRelations.length > 1;
                        for (j = 0; j < alias.parentsRelations.length; j += 1) {
                            let parentRelation = alias.parentsRelations[j];
                            let parentNode = nodes.find(element => element.alias.id == parentRelation.parentId);

                            if (parentNode) {
                                if (parentRelation.isPrimary) {
                                    node.hasParent = true;
                                    parentNode.children.push(node);
                                }
                                else {
                                    let secondaryNode = this.createSecondaryNode(alias);
                                    secondaryNode.hasParent = true;
                                    parentNode.children.push(secondaryNode);
                                }
                            }
                        }
                    }
                }
                this.sortAliasTree();
            },
            createPrimaryNode(alias) {
                let node = {
                    nodeId: this.nextNodeId,
                    alias: alias,
                    isPrimary: true,
                    hasParent: false,
                    hasCopy: false,
                    children: [],
                    $droppable: true,
                }
                this.nextNodeId += 1;
                return node;
            },
            createSecondaryNode(alias) {
                let node = {
                    nodeId: this.nextNodeId,
                    alias: alias,
                    isPrimary: false,
                    hasParent: false,
                    hasCopy: true,
                    children: [],
                    $droppable: false,
                }
                this.nextNodeId += 1;
                return node;
            },
            sortAliasTree() {
                this.aliasesTree = this.aliasesTree
                    .sort((a, b) => (a.isPrimary - b.isPrimary)
                        || ((a.alias.codeNumber || 'z').replace(/\s/g, '').localeCompare((b.alias.codeNumber || 'z').replace(/\s/g, ''))));
            },
            searchTreeNode(predicate) {
                const results = [];
                const stack = [];
                stack.push.apply(stack, this.aliasesTree);
                while (stack.length) {
                    const node = stack.shift();
                    if (predicate(node))
                        results.push(node);
                    node.children && stack.push(...node.children);
                }
                return results;
            },
            addAlias() {
                return budgetAliasesService
                    .create({
                        presentationId: this.presentationId,
                        codeId: this.newAlias.codeId,
                        codeType: this.codeType,
                        name: this.newAlias.name,
                        childrenRelations: []
                    })
                    .then(response => {
                        let alias = response.data;
                        let node = this.createPrimaryNode(alias);
                        this.aliasesTree.push(node);
                        this.newAlias.codeId = null;
                        this.newAlias.name = "";
                    })
                    .catch(defaultHandleErrorFunction);
            },
            copyAliasNode(node, path, tree) {
                if (node && node.isPrimary) {
                    let secondaryNode = this.createSecondaryNode(node.alias);
                    node.hasCopy = true;
                    this.aliasesTree.push(secondaryNode);
                    this.sortAliasTree();
                }
            },
            deleteAliasNode(node, path, tree) {
                if(node && node.children.length == 0) {
                    let parentNode = tree.getNodeParentByPath(path);

                    tree.removeNodeByPath(path);

                    //Update parent relations without alias
                    if(parentNode)
                        this.updateAliasRelation(parentNode);

                    //Delete alias
                    if(node.isPrimary)
                        budgetAliasesService
                            .delete(node.alias.id)
                            .catch(defaultHandleErrorFunction);

                    var nodeCopies = this.searchTreeNode(element => element.alias.id == node.alias.id);
                    console.log(nodeCopies.length);
                    if (nodeCopies.length == 1)
                        nodeCopies[0].hasCopy = false;
                }
            },
            aliasNodeChanged(node) {
                budgetAliasesService
                    .update({
                        id: node.alias.id,
                        codeId: node.alias.codeId,
                        name: node.alias.name,
                        isDisplayed: node.alias.isDisplayed,
                        childrenRelations: node.alias.childrenRelations
                    })
                    .catch(defaultHandleErrorFunction);
            },
            treeChanged(store) {
                let tree = store.targetTree;
                let childNode = store.dragNode;

                let previousParentNode = tree.getNodeParentByPath(store.startPath);
                if (previousParentNode)
                    this.updateAliasRelation(previousParentNode);

                let newParentNode = tree.getNodeParentByPath(store.targetPath);
                if (newParentNode)
                    this.updateAliasRelation(newParentNode);
            },
            updateAliasRelation(aliasNode) {
                let newChildrenRelations = aliasNode.children.map(child => ({
                    childId: child.alias.id,
                    isPrimary: child.isPrimary
                }));
                budgetAliasesService
                    .update({
                        id: aliasNode.alias.id,
                        codeId: aliasNode.alias.codeId,
                        name: aliasNode.alias.name,
                        isDisplayed: aliasNode.alias.isDisplayed,
                        childrenRelations: newChildrenRelations
                    })
                    .catch(defaultHandleErrorFunction);
            },
            nodeClicked(event) {
                //Have to manual remove focus from input elements in node
                if (this.editMode) {
                    let inputElements = Array.from(document.getElementsByClassName('node-input-element'));
                    if (!inputElements.includes(event.target)) {
                        var someInputElementIsFocused = inputElements.some(element => document.activeElement === element);
                        if (someInputElementIsFocused)
                            document.activeElement.blur();
                    }
                }
            },
        },
        watch: {
            aliasesList: {
                deep: false,
                handler(newVal, oldVal) {
                    this.updateAliasTree(this.aliasesList);
                }
            }
        },
        created() {
            this.updateAliasTree(this.aliasesList);
        }
    }

    const budgetAliasesService = new BudgetAliasesService();
</script>